! ---------------------------------------------------- SMC2PSA_Rot_GMRot_Interp_Acc_Rot_Osc_TS
      Program SMC2PSA_Rot_GMRot_interp_acc_Rot_Osc_TS

! Reads a SMC-format filename from a control file and computes various measures of
! seismic intensity 

! The program can write the output in two ways:
! 1) a separate file for each pair of time-series files, with periods as rows. 
! 2) a single file with time series file names as rows and seismic intensity measures at various 
!    periods as columns, as in the NGA flatfile.
 
! Structure of control file:
! Line 1 follows:
!!Control file for program SMC2PSA_Rot_GMRot_interp_acc_Rot_Osc_TS
!! Revision of program involving a change in the control file on this date:
!   02/09/18
!!Summary file name:
! smc2psa_rot_gmrot_interp_acc_rot_osc_ts.sum
!!d_rot_angle
!  1.0 
!!Specify response spectral periods
!! yfull: the full set of the PEER NGA-W2 periods
!! ysub:  a subset of the PEER NGA periods  
!! nlog: in the next line give nperiods, per_low, per_high.
!! nlin: in the next line give nperiods and the period values
!! yfull
! nlin
!!if "nlog" or "nlin", then specify periods (see above).
!!need these as placeholders, even if use NGA periods
!! 5 0.01 12 ! for nlog
!  10  0.01 0.025 0.05 0.1 0.2 0.4 1.0 2.0 4.0 8.0
!!Fractional damping: ndamp, damp(1), damp(2), ..., damp(ndamp):
! 5 0.01, 0.02, 0.05, 0.10, 0.20
!!t4mean (removes a mean from the whole record, where the mean is
!!  determined from t = 0 to t = t4mean.  If t4mean = 0.0,
!!  the mean of the whole record is used, and if t4mean < 0, no mean is
!!  removed.  
!! NOTE: need entries even if the parameter is not used (because read
!! info use list-directed [unformatted] input) 
!! Note that if working with a processed record that includes the 
!! complete time series produced by the processing (e.g., the padded time series
!! for acausal filtering or the post-processing baseline corrected time series
!! produced from pad-stripped or pass-through data in the first NGA project), 
!! it is inadvisible to remove the mean as this may 
!! produce unintended distortions at long periods; in this case set t4mean < 0.0.
!! If the record is pad-stripped, however, as provided by most
!! data centers, without post-processing to remove drifts in displacement,
!! a mean determined from the overall record probably should be 
!! removed.  But in this case the displacement will probably be inaccurate
!! (compared to the displacement derived from the padded, filtered acceleration
!! time series), it may be that a better approach is to specify the initial
!! velocity and displacement of the record---I am working on that (11/26/10):
! -10.0  
!!Skip analysis (including rotation) if npts differ by more than:
!  2
!!Tmax4Penalty: Used in the computation of the period-independent GMRotI values.  Tmax4Penalty 
!!  is used in the computation of the penalty function, which is 
!!  computed up to the period Tmax4Penalty.  Note that Tmax4Penalty 
!!  specified may be reset according to this function
!!
!!     Tmax4Penalty = min(Tmax4Penalty_in, Tmax_PSA),
!!
!!  where is the longest period for which PSA is  computed (e.g., 10 s 
!!  for the NGA periods),  
!!    In addition, if the response to "Use the low-cut filter" below is "Y" and
!!  the low-cut filter frequencies flc1 and flc2 are specified in real_head(33)
!!  of the smc file containing the acceleration time series, then 
!!
!!     Tmax4Penalty = min(1/max(flc1,flc2), Tmax_PSA).  
!!
!!  If flc1 and flc2 are not specified, then Tmax4Penalty is given as
!!  if the response to "Use the low-cut filter" below is "N"
!  20.0
!!Use the low-cut filter frequencies in the choice of tmax4penalty, used
!!  in computing the penalty function?
!!  This option is provided for testing the influence of flc1 and flc2 on the
!!  seismic intensity measures for which the rotation angle is independent of period
!!  (e.g., gmroti50).   The PSA will be computed up to the longest period
!!  specified in the lines above "Damping value", regardless of the low-cut filter
!!  frequency.  It is up to the user to decide on the longest period for which
!!  the response spectra should be used (e.g., Tusable = eta*1/max(flc1, flc2), 
!!  where eta might be 1/2 to be conservative or 1/1.25 as assumed for many of the
!!  records in the NGA flatfile; see lowest_usable_freq_for_response_spectra_v20.pdf 
!!  in the "daves notes" page on www.daveboore.com or Akkar, S. and J. J. Bommer (2006), 
!!  Infuence of long-period filter cut-off on elastic spectral displacements,
!!  Earthquake Engng Struct. Dyn. 35, 1145-1165
!  N
!!If the low-cut filter frequencies are to be used to obtain Tmax4Penalty, 
!!  1/max(flc1, flc2) is multiplied by the inverse of the factor to obtain 
!!  Tmax4Penalty (e.g., if the factor below is 1.5, then 
!!  Tmax4Penalty = 1/(1.5*max(flc1, flc2))).  The factor is included to allow
!!  consistency with the calculation of Tusable in the PEER NGA flatfile
!!  (in the flatfile the factor is most commonly 1.25, although 1.5 or
!!  even 2.0 may be more appropriate in many cases---see the notes and paper
!!  referred to above) (Note: a dummy entry is needed even if 
!!  flc1, flc2 are not used to obtain Tmax4Penalty):
!  1.5
!!Output separate files for each pair of time series? (Y,N):
! N
!!
!!Stem name of output file (a period is not needed at the end of the character string; 
!!  the time series file name will be appended to this string IF the option above is "Y"):
! smc2psa_rot_gmrot_interp_acc_rot_osc_ts
!!
!!Are the units of acceleration in g (Y/N):
!! if N, I assume that the units are cm/s/s and g2gals is not used.  If N but the units are not gals,
!!   it is up to the user to scale the output appropriately.
!! if Y, the program uses g2gals to convert to cm/s/s before doing the processing.
!!The accelerations from the PEER databases are in g (usually?  always?), whereas
!!those in smc format from the USGS are in cm/s/s.  But always check this.
! Y
!!Do you want PSA, PGA values in cm/s/s (gals)? (Y,N):
!!Note. Because the acceleration has been converted to cm/s/s units, if not already in cm/s/s, before processing:
!!  if N: the output of the processing is multiplied by 1.0/g2gals.
!!  if Y: g2gals is not used.
! N
!!g2gals (usually 981.0; 1.0 is OK if input is in gals and output is in gals, but in this case, g2gals is
!!not used, so it probably should be left as 981.0 or whatever other g/gals factor is being used.)
!  981.0
!!Fraction of the smaller of the largest absolute motions on each of the two horizontal components.
!! This is used in selecting subsets for rotation. The larger the value of fraction,
!! the smaller the output time series (0.0 selects the whole time series).
!! This meaning of "fraction" may be confusing, as it might be natural to think that 
!! the larger the fraction, the more of the oscillator time series will be rotated.  
!! But it is just the opposite.  Fraction is used in setting the level "alevel" above 
!! which the subset of the oscillator time series is chosen, according to
!!               alevel = fraction*amin1(peak_y1, peak_y2)
!! Wang et al. (2018) recommend these choices for the fraction:
!! Measure   fraction
!!  RotD00    0.0
!!  GMRotI50  0.5
!!  RotD50    0.7
!!  RotD100   0.7
!!  Wang et al. (2018) only compared fraction = 0.0 results with fraction = 0.5 and 0.7, so it could be that
!! their recommendations are conservative (the smaller the value of fraction, the longer the
!! run time).  For example, it could be that a value of fraction between 0.0 and 0.5 would 
!! be adequate for RotD00.
! 0.70
!!The interpolation factor, specifying the factor used to extend the original time series
!! for resampling of the input time series using a FFT (this must be a power of two--1, 2, 4, 8, 16,
!! ...; the program checks for this; the interpolation can be turned off by specifying 1 as 
!! the interpolation factor). I recommend an interpolation factor of 8; there is no advantage to 
!! using a greater factor, since for short period response spectra, the Nyquist frequency is the 
!! critical frequency, not the oscillator frequency (see Wang et al., 2018)
! 8
!!List of file names (assumes pairs of files): 
!! The order of component 1 and component 2 makes no difference to the gmrot and rot
!! values, but the azimuth of component 2 relative to component 1 (+90 or -90) does
!! make a difference for the azimuth corresponding to rotd100. 
!! In this version of the program I do use the actual azimuths, if available.  If
!! they not specified in the smc file (int_head(14)=inull), I set azm_in(1) = 0.0
!! and azm_in(2) = 90.0.   If it is known that azm_in(2) = azm_in(1) - 90, then
!! the order of the pair of files for each record should be switched, as then
!! the angles for rotd00 and rotd100 will be relative to azm_in(1).
!!
!! ********  NOTE *************
!! The pairs of files must be time aligned
!! ********  NOTE *************
!!
!    0516a.smc
!    0516c.smc
!    0526a.smc
!    0526c.smc
!  StoP

! Sign conventions:  the azimuth of the radial component is 180+azimuth from
! station to reference point, and the transverse component is this radial 
! azimuth plus 90 degrees.  This should be equivalent to the convention
! in Aki and Richards, Fig. 4.10, p. 96.

! This is incomplete, because the program will eventually also deal with case
! for which i_spcfy_fname = 1.  A program that works 
! with this is smcrtold (the old version of smc_rot)

! Dates: 09/23/12 - This is a new version which rotates a subset of the as-recorded  
!                   psa, vel, and dis time series.  The subset is chosen using Norm Abrahamson's
!                   algorithm.  This program is based on smc2psa_rot_gmrot_call_rdcalc_each_rot_angle.for and
!                   smc2psagmrot_25jun09_uses_osc_rot.for.  See the change log in those programs for previous
!                   modifications.  The current program is named smc2psa_rot_gmrot_rot_osc_ts.for 
!                   while being developed; once it is finished, I'll probably rename it smc2psa_rot_gmrot.
!        09/29/12 - Substitute interpolate_time_series_using_fork for
!                   interpolate_time_series_using_fft.  In tests of the latter, I found it did not
!                   produce the input values at the sample points (close, but not exact---see work
!                   in C:\forprogs\develop\test_smc2psa_rot_gmrot_rot_osc_ts)
!        05/16/13 - Use current set of NGA periods
!        01/15/15 - Deallocate some arrays if exit BIG LOOP OVER INPUT FILES by using CYCLE
!        01/16/15 - Replace Lahey intrinsic routine "timer" with my more general 
!                   routine "timer_subroutine" (this requires specifying time1 and time2 as at least 64 bit real).
!        06/17/16 - Treat flc=0 properly.
!        07/21/16 - Increase number of digits for n_a_subset, n_v_subset, and n_d_subset 
!        07/23/16 - Replace npts, etc output with log10(npts), to avoid ***** in output for long time series
!                   particularly with a large interpolation power, such as 32 (which
!                   results in errors when split_smc2psa... reads the smc2psa... output file)
!                 - Change "alog" to "log".
!        11/05/16 - Increase output format to avoid "****" in summary file
!        11/07/16 - Do not include the path of the input file in the output file name.
!        01/25/18 - Add azm for RotD50 to output (use the azm of PSA closest to RotD50)
!        02/03/18 - Because RotD50 is equidistance from the two points in the middle of the distribution
!                   indices 90 and 91 when sorted by value), write the rotation angles for those two points
!                   (what I did before makes no sense).
!        02/07/18 - Call subroutine rdrvaa_rd_rv_ts rather than rdrvaa_rd_ts.  Here are comments
!                   from rdrvaa_rd_rv_ts about why I did this:
!        02/07/18 - Modified from rdrvaa_rd_ts.for, and nows writes out ts_rv, following rscalc_ts. 
!                   I am trying to decrease the number of programs that compute oscillator 
!                   response time series, as things have gotten quite confusing.  The
!                   program smc2psa_rot_gmrot_interp_acc_rot_osc_ts.for had used the
!                   subroutine rdrvaa_rd_ts, perhaps to avoid the extra time in computing
!                   ts_rv, but that extra cost is minor compared to the confusion of having
!                   too many programs that do almost the same thing.  So now 
!                   smc2psa_rot_gmrot_interp_acc_rot_osc_ts.for and smc2rs_ts.for will both
!                   call the subroutine rdrvaa_rd_rv_ts.  The subroutines rscalc_ts.for, rdcalcts.for, 
!                   and rdrvaa_rd_ts.for have all been saved with their latest dates as an extension,
!                   and the files with the actual names have been modified by deleting all
!                   content and adding the line
!        02/09/18 - Add a query to the control file asking if the units of acceleration are g.
!                   If it is, the program converts the input acceleration to cm/s/s.  Another
!                   input parameter controls whether the output with units of acceleration (pga, psa)
!                   have units of g or gals.
!        11/06/20 - Increase number of comments to skip
                
      character date_ctl_correct*8, date_ctl_in*30

      character char_head(11,2)*80, comments(200,2)*80, buf_file*200
      character cmnts2skip(60)*80   
      character buf*200
      character format4npts_dt*20, local_path*200  ! For nga2psa_rot_gmrot
      character input_path*200
      
      character version_ctl*8, version_in*30

      integer idate_time_values(8)
      
      real(kind=8) :: time_stop_all_files, time_start_all_files, 
     :                time_stop_one_file,  time_start_one_file

      
      real fraction4subset_selection
      
      real time_sec_start, time_sec_stop
      real time_sec_start_one_file, time_sec_stop_one_file 
      
      real damp(11)  ! Increased from 10 to 11 on 22sep12, as in nga2psa_rot_gmrot
      integer ndamp
      
      integer nu_out(11)  ! Increased from 10 to 11 on 22sep12, as in nga2psa_rot_gmrot
      
      integer int_head(48,2), nc_f_in(2),  nc_f_out(11), nc_rc(2)
      integer npts_in(2), npts(2), nc_local_path, nc_input_path

      real real_head(50,2), work(5000), work_rot180(400), 
     :     work_angle4rot(400), rot_angle4gmrot(400)
      real alat_sta(2), along_sta(2)
    
      real rd_ar(2), rv_ar(2), aa_ar(2)
    
      real a_in(:,:), a_in_interp(:,:), 
     :    a_out(:,:), vel(:,:), dis(:,:), rd_ar_ts(:,:), dum_rv(:),
     :    temp_a_in(:)
      allocatable :: a_in, a_in_interp, 
     :    a_out, vel, dis, rd_ar_ts, dum_rv,
     :    temp_a_in 

      real vel4gmroti(:), dis4gmroti(:)
      allocatable :: vel4gmroti, dis4gmroti
      
      real a4rot(:,:), v4rot(:,:), d4rot(:,:), rd4rot(:,:)
      allocatable :: a4rot, v4rot, d4rot, rd4rot
      
      real a_subset(:,:), v_subset(:,:), d_subset(:,:), 
     :     rd_subset(:,:), t_subset(:) 
      allocatable :: a_subset, v_subset, d_subset, 
     :     rd_subset, t_subset 
      
      integer n_a_subset, n_v_subset, n_d_subset, n_rd_subset(451,11)
      
      real period(451), rd(2), rv(2), aa(2), psa(2), psv(2),
     :    pga(2), pgv(2), pgd(2),
     :    pga_rot180(400), pgv_rot180(400), pgd_rot180(400), 
     :    pga_gmrot(400), pgv_gmrot(400), pgd_gmrot(400),
     :    gmean(400,451,11), gmrot_norm(400,451), rot_norm(400,451), 
     :    penalty(400), gm50(451),
     :    gmrotd50(451,11), gmrotd00(451,11), gmrotd100(451,11),
     :    gmroti50(451,11), gmangi50(451,11),
     :    rotd50(451,11), rotd00(451,11), rotd100(451,11),
     :    roti50(451,11), roti100(451,11),
     :    rotd00ang(451,11), rotd50ang1(451,11), rotd50ang2(451,11), 
     :    rotd100ang(451,11), 
     :    roti50ang(451,11), roti100ang(451,11)
      real gmrotd00ang(451,11), gmrotd100ang(451,11)
      real yout1(451), yout2(451), yout3(451), yout4(451), 
     :     yout5(451), yout6(451), yout7(451)
      real psa_rot180(400,451,11), rot_angle4rot(400) !400=nrot, 451 = nper
                                                      ! 11=ndamp
      real psa_1_ar(400,11), psa_2_ar(400,11), psa_larger_ar(400,11), 
     :      psv_1_ar(400,11), psv_2_ar(400,11), psa_gm_ar(400,11),
     :      aa_1_ar(400,11), aa_2_ar(400,11), 
     :      rv_1_ar(400,11), rv_2_ar(400,11),
     :      rd_1_ar(400,11), rd_2_ar(400,11)
      real omega, omega2
      real per4az(11)
      integer ndx4az(11)
      integer index_rot180(400)
      
      real pga_gmroti50(11), pgv_gmroti50(11), pgd_gmroti50(11), 
     :      gmroti50angle(11)

      real flc(2)
      integer nslope(2)
      
      integer nper_record(5000)
      real iflag4rec(5000)
      
      character f_avg_std*100
         
      integer inull(2)
      
      real rnull(2), azm_in(2), azm4file(200), sps_in(2), sps(2)
      character buf4*4, f_ctl*80, f_sum*300,
     :          buf_out*79
      character  f_in(2)*300, f_out(10)*300, f_out_in*300, 
     :           c_az*7, rc(2)*12, temp_f_in*300
      character per4az_c*5, colhead1(200)*12, colhead2(200)*12, frmt_c*80
      character use_nga_per4gm*10, colhead(200)*10, per_c*7, 
     :          units_acc_vel_c*8
     
      character f_npts*300
       
      logical f_exist
      logical rmv_trnd, use_flc4tmax4penalty, output_in_gals, 
     :     output_separate_files
      logical dc_remove, accel_units_g
     
      
      real per_nga_full(113), per_nga_sub(24)   ! include pgv and pga as per = -1.0, 0.0
      
!As of 14mar13
      data per_nga_full/
     :  -1.0, 0.0,   
     : 0.010, 0.020, 0.022, 0.025, 
     : 0.029, 0.030, 0.032, 0.035,
     : 0.036, 0.040, 0.042, 0.044,
     : 0.045, 0.046, 0.048, 0.050,
     : 0.055, 0.060, 0.065, 0.067, 
     : 0.070, 0.075, 0.080, 0.085, 
     : 0.090, 0.095, 0.100, 0.110, 
     : 0.120, 0.130, 0.133, 0.140, 
     : 0.150, 0.160, 0.170, 0.180,
     : 0.190, 0.200, 0.220, 0.240,
     : 0.250, 0.260, 0.280, 0.290,
     : 0.300, 0.320, 0.340, 0.350,
     : 0.360, 0.380, 0.400, 0.420,
     : 0.440, 0.450, 0.460, 0.480,
     : 0.500, 0.550, 0.600, 0.650,
     : 0.667, 0.700, 0.750, 0.800,
     : 0.850, 0.900, 0.950, 1.000,
     : 1.100, 1.200, 1.300, 1.400,
     : 1.500, 1.600, 1.700, 1.800, 
     : 1.900, 2.000, 2.200, 2.400,
     : 2.500, 2.600, 2.800, 3.000,
     : 3.200, 3.400, 3.500, 3.600, 
     : 3.800, 4.000, 4.200, 4.400,
     : 4.600, 4.800, 5.000, 5.500,
     : 6.000, 6.500, 7.000, 7.500,
     : 8.000, 8.500, 9.000, 9.500,
     :10.000,11.000,12.000,13.000,
     :14.000,15.000,20.000/
     
      nper_nga_full = 113 ! including pga, pgv

 
      data per_nga_sub/
     :   -1.000,
     :    0.000,
     :    0.010,
     :    0.020,
     :    0.030,
     :    0.040,
     :    0.050,
     :    0.075,
     :    0.100,
     :    0.150,
     :    0.200,
     :    0.250,
     :    0.300,
     :    0.400,
     :    0.500,
     :    0.750,
     :    1.000,
     :    1.500,
     :    2.000,
     :    3.000,
     :    4.000,
     :    5.000,
     :    7.500,
     :   10.000/
      nper_nga_sub = 24 

      pi = 4.0*atan(1.0)
      twopi = 2.0*pi
      d2r = pi/180.0
      nper_dimen = 451
      nrot_dimen = 400
      
      f_exist = .false.
      DO while (.not. f_exist)
        f_ctl = ' '
        write(*, '(a)') 
     :    ' Enter name of control file '//
     :       '(Enter = smc2psa_rot_gmrot_interp_acc_rot_osc_ts.ctl): '
        read(*, '(a)') f_ctl
        IF (f_ctl == ' ') 
     :        f_ctl = 'smc2psa_rot_gmrot_interp_acc_rot_osc_ts.ctl'
        call trim_c(f_ctl,nc_f_ctl)
        inquire(file=f_ctl(1:nc_f_ctl), exist=f_exist)
        IF (.not. f_exist) THEN
          write(*,'(a)') ' ******* FILE DOES NOT EXIST ******* '
        END IF
      END DO

      call get_lun(nu_ctl)
      open(unit=nu_ctl,file=f_ctl(1:nc_f_ctl),status='unknown')

! Check date of control file:
      call skipcmnt(nu_ctl, cmnts2skip, nc_comments)
      date_ctl_in = ' '
      read(nu_ctl,'(a)') date_ctl_in
      call trim_c(date_ctl_in,nc_date_ctl_in)
      date_ctl_correct = ' '
      date_ctl_correct = '02/09/18'
      call trim_c(date_ctl_correct,nc_date_ctl_correct)

      if (date_ctl_correct(1:nc_date_ctl_correct) /= 
     :    date_ctl_in(1:nc_date_ctl_in)) then
        write(*,'(a)') 
     :     ' The control file has the wrong date; update your '//
     :       'control file and rerun the program!'
        write(*,'(a)') 
     :     ' The date for the control file you used is '
     :       //date_ctl_in(1:nc_date_ctl_in)
        write(*,'(a)') 
     :     ' The correct date is '
     :       //date_ctl_correct(1:nc_date_ctl_correct)
        close(nu_ctl)
        stop
      end if
! Check date of control file:

      call skipcmnt(nu_ctl,cmnts2skip, nc_comments)
      f_sum = ' '
      read(nu_ctl,'(a)') f_sum
      call get_lun(nu_sum)
      call trim_c(f_sum,nc_f_sum)
      open(unit=nu_sum,file=f_sum(1:nc_f_sum),status='unknown')    
      write(nu_sum,'(a)') ' Summary file for program '//
     :           'SMC2PSA_Rot_GMRot_Interp_Acc_Rot_Osc_TS'
      write(nu_sum,'(2a)') '   Using control file: ', f_ctl
      DO i = 1, nc_comments
        write(nu_sum,'(a)') cmnts2skip(i)
      END DO
      write(nu_sum,'(a)') f_sum

      call skipcmnt(nu_ctl,cmnts2skip,nc_cmnts2skip)
      DO i = 1, nc_cmnts2skip
        write(nu_sum,'(1x,a)') cmnts2skip(i)(1:79)
      END DO
      read(nu_ctl,*) d_rot_angle

      rot_low = 0.0
      rot = rot_low
      nrot90 = 1
      do
        rot = rot + d_rot_angle
        IF (rot >= 90.0) exit
        rot_high = rot
        nrot90 = nrot90 + 1
      END DO
      
      write(nu_sum,'(a)') 
     :  ' d_rot_angle, nrot90, rot_high, '//
     :   'rot_high from (nrot90-1)*d_rot_angle = ' 
      write(nu_sum,*) 
     :    d_rot_angle, nrot90, rot_high, float(nrot90 - 1)*d_rot_angle
      IF (nrot90 > nrot_dimen) THEN
        nrot90 = nrot_dimen
        d_rot_angle = 90.0/float(nrot90)
        write(nu_sum,'(a,1x,i4)') ' resetting nrot to ', nrot90
        write(nu_sum,'(a,1x,i4)') ' and d_rot_angle to ', d_rot_angle
      ELSE        
        write(nu_sum,'(a,1x,i4)') ' nrot90 = ', nrot90
      END IF
      
      n_rot180 = 2*nrot90       ! nrot90 only spans 0 to 90 degrees, whereas the rot measures need 0 to 180 degrees
      write(nu_sum,'(a, 1x,i8, 1x,i8)')  
     :  ' n_rot180, nrot_dimen = ', n_rot180, nrot_dimen 
      IF (n_rot180 > nrot_dimen) THEN
        print *,' ERROR: n_rot180 > nrot_dimen; QUIT!!!'
        stop
      END IF

      call skipcmnt(nu_ctl,cmnts2skip,nc_cmnts2skip)
      use_nga_per4gm = ' '
      read(nu_ctl,'(a)') use_nga_per4gm
      call upstr(use_nga_per4gm)
      call trim_c(use_nga_per4gm,nc_use_nga_per4gm)
      
      call skipcmnt(nu_ctl,cmnts2skip,nc_cmnts2skip)
      DO i = 1, nc_cmnts2skip
        write(nu_sum,'(1x,a)') cmnts2skip(i)(1:79)
      END DO
      
      IF (use_nga_per4gm(1:nc_use_nga_per4gm) == 'YFULL') THEN
        call skip(nu_ctl,1)
        nper_max = nper_nga_full - 2
        DO i = 1, nper_max
          period(i) = per_nga_full(i+2)
        END DO
      ELSE IF (use_nga_per4gm(1:nc_use_nga_per4gm) == 'YSUB') THEN
        call skip(nu_ctl,1)
        nper_max = nper_nga_sub - 2
        DO i = 1, nper_max
          period(i) = per_nga_sub(i+2)
        END DO
      ELSE IF (use_nga_per4gm(1:nc_use_nga_per4gm) == 'NLOG') THEN
        read(nu_ctl,*) nper_specify, per_low, per_high
        nper_max = nper_specify
        IF (nper_max > nper_dimen) THEN
          nper_max = nper_dimen
          nper_specify = nper_dimen
          write(nu_sum,'(a,1x,i8)') 
     :          ' Resetting nper_max to ', nper_max
          write(nu_sum,'(a,1x,i8)') 
     :          ' Resetting nper_specify to ', nper_specify
        END IF
        dlogt = log10(per_high/per_low)/float(nper_specify-1)
        DO i = 1, nper_max
          period(i) = per_low*10.0**(float(i-1) * dlogt)
        end DO   
      ELSE IF (use_nga_per4gm(1:nc_use_nga_per4gm) == 'NLIN') THEN
        read(nu_ctl,*) nper_specify, (period(iper),iper=1,nper_specify)
        nper_max = nper_specify
      ELSE
        print *, ' ERROR: Invalid variable '//
     :     use_nga_per4gm(1:nc_use_nga_per4gm)//' QUITTING'
        close (nu_ctl)
        close (nu_sum)
        STOP
      END IF
      
      write(nu_sum,'(1x,a,1x,i8)') ' nper_max = ', nper_max

      call skipcmnt(nu_ctl,cmnts2skip,nc_cmnts2skip)
      DO i = 1, nc_cmnts2skip
        write(nu_sum,'(1x,a)') cmnts2skip(i)(1:79)
      END DO
      read(nu_ctl,*) ndamp, (damp(i), i=1,ndamp)
      write(nu_sum,*) ndamp, (damp(i), i=1,ndamp)
      
       
      call skipcmnt(nu_ctl,cmnts2skip,nc_cmnts2skip)
      DO i = 1, nc_cmnts2skip
        write(nu_sum,'(1x,a)') cmnts2skip(i)(1:79)
      END DO
      read(nu_ctl,*) t4mean_in
      write(nu_sum,*) t4mean_in
         
      call skipcmnt(nu_ctl,cmnts2skip,nc_cmnts2skip)
      DO i = 1, nc_cmnts2skip
        write(nu_sum,'(1x,a)') cmnts2skip(i)(1:79)
      END DO
      read(nu_ctl,*) npts_skip
      write(nu_sum,*) npts_skip
         
      call skipcmnt(nu_ctl,cmnts2skip,nc_cmnts2skip)
      read(nu_ctl,*) tmax4penalty_in
      write(nu_sum,'(1x,a, 1x,f7.4, 1x,f7.4)') 
     :   ' tmax4penalty (original), period(nper_max) = ', 
     :     tmax4penalty_in, period(nper_max)

! Reset tmax4penalty_in IF necessary (it cannot be greater than the maximum period
! for which the response spectra are computed, but it can be smaller than 
! this period).  It may be reset
! again, later in the program, based on the low-cut filter (IF that option is chosen)
 
        IF (tmax4penalty_in < period(nper_max)) THEN
          DO i = 1, nper_max
            IF (period(i) > tmax4penalty_in) THEN
              nper4penalty = i-1
              EXIT   
            END IF
          END DO
          tmax4penalty = period(nper4penalty)
        ELSE
          tmax4penalty = period(nper_max)
          nper4penalty = nper_max
          write(nu_sum,'(1x,a,1x,f6.2)') 
     :   ' tmax4penalty reset to period(nper_max). It now equals ',
     :     tmax4penalty
        END IF
        
        write(nu_sum,*)
        write(nu_sum,'(a, 1x,i4, 1x,f5.1, 1x,f5.1, 1x,i8)') 
     :  ' nper_max, '// 
     :  ' tmax4penalty_in, tmax4penalty, nper4penalty = ', 
     :    nper_max, 
     :    tmax4penalty_in, tmax4penalty, nper4penalty 
        write(nu_sum,*)
        
      call skipcmnt(nu_ctl,cmnts2skip,nc_cmnts2skip)
      buf = ' '
      read(nu_ctl,'(a)') buf
      call upstr(buf)
      call trim_c(buf, nc_buf)
      IF (buf(1:1) == 'Y') THEN
        use_flc4tmax4penalty = .true.
      ELSE
        use_flc4tmax4penalty = .false.
      END IF
      
      write(nu_sum,'(1x,a,1x,l1)') 
     :    ' Use flc when computing the penalty function? = ', 
     :      use_flc4tmax4penalty

      call skipcmnt(nu_ctl,cmnts2skip,nc_cmnts2skip)
      read(nu_ctl,*) fusable_div_flc
      write(nu_sum,'(a, 1x,f6.3)') 
     :   ' fusable_div_flc = ',  fusable_div_flc
           
        
      call skipcmnt(nu_ctl,cmnts2skip,nc_cmnts2skip)
      buf = ' '
      read(nu_ctl,'(a)') buf
      call upstr(buf)
      call trim_c(buf, nc_buf)
      IF (buf(1:1) == 'Y') THEN
        output_separate_files = .true.
      ELSE
        output_separate_files = .false.
      END IF
      
      call skipcmnt(nu_ctl,cmnts2skip,nc_cmnts2skip)
      DO i = 1, nc_cmnts2skip
        write(nu_sum,'(1x,a)') cmnts2skip(i)(1:79)
      END DO
      f_out_in = ' '
      read(nu_ctl,'(a)') f_out_in
      call trim_c(f_out_in,nc_f_out_in)
      write(nu_sum,'(a)') f_out_in(1:nc_f_out_in)
      
      call skipcmnt(nu_ctl,cmnts2skip,nc_cmnts2skip)
      buf = ' '
      read(nu_ctl,'(a)') buf
      call upstr(buf)
      call trim_c(buf,nc_buf)
      if (buf(1:1) == 'Y') then
        accel_units_g = .true.
      else
        accel_units_g = .false.
      end if
      
      call skipcmnt(nu_ctl,cmnts2skip,nc_cmnts2skip)
      buf = ' '
      read(nu_ctl,'(a)') buf
      call upstr(buf)
      call trim_c(buf, nc_buf)

      call skipcmnt(nu_ctl,cmnts2skip, nc_cmnts2skip)
      read(nu_ctl,*) g2gals
      write(nu_sum,'(a, 1x,f8.2)') ' g2gals = ',  g2gals

      units_acc_vel_c = ' '
      IF (buf(1:1) == 'Y') THEN  ! Want output in gals.  
                                 ! Note that the input acceleration will be 
                                 ! scaled to gals even if it is originally in g
                                 ! (this is what accel_units_g is used for). 
        output_in_gals = .true.
        acc_factor = 1.0
        units_acc_vel_c = 'gal,cm/s'
      ELSE
        output_in_gals = .false.
        acc_factor = 1.0/g2gals
        units_acc_vel_c = '  g,cm/s'
      END IF
      
      call skipcmnt(nu_ctl,cmnts2skip, nc_cmnts2skip)
      read(nu_ctl,*) fraction4subset_selection
      write(nu_sum,'(a, 1x,f5.3)') ' fraction4subset_selection = ',  
     :                               fraction4subset_selection

      call skipcmnt(nu_ctl,cmnts2skip,nc_cmnts2skip)
      read(nu_ctl,*) 
     :   interpolate_factor  ! This must be a power of two--check
       if (modulo(log(real(interpolate_factor)), log(2.0)) /= 0) then
         print *,' interpolate_factor= ', 
     :              interpolate_factor, ' not a power of 2; QUIT!!'
         close(nu_ctl)
         stop
       end if




      IF (.not. output_separate_files) THEN  ! Open output files for each damping
                                             ! and write column headers                                             ! 
      
        DO iper = 1, nper_max
          per_c = ' '
          write(per_c,'(f7.4)') period(iper)
          call trim_c(per_c,nc_per_c)
          colhead(iper) = ' '
          write(colhead(iper)(1:10),'(a10)') 'PER0000000'
          colhead(iper)(10-nc_per_c+1:10) = per_c(1:nc_per_c)
        END DO

             
        LOOP1 OVER DAMP: DO i = 1, ndamp
        
          f_out(i) = ' '
          f_out(i) = f_out_in(1:nc_f_out_in)//'.damp'
          call trim_c(f_out(i), nc_f_out(i))
          write(f_out(i)(nc_f_out(i)+1:nc_f_out(i)+5),'(f5.3)') damp(i)
          call trim_c(f_out(i), nc_f_out(i))
          f_out(i) = f_out(i)(1:nc_f_out(i))//'.out'
          call trim_c(f_out(i), nc_f_out(i))
          call get_lun(nu_out(i))
          open(nu_out(i),file=f_out(i)(1:nc_f_out(i)),status='unknown')

!Write column headers of output file: 

          write(nu_out(i),'(a)') 
     :  '! Note: pga_rotnn and pgv_rotnn, for nn = 00, 50 and 100, '// 
     :  'are based on the distributions of pga and pgv over'
          write(nu_out(i),'(a)') 
     :   '! all rotation angles, in the same way as rotdnn. '//  
     :   'Note that for consistency with the notation "gmrotdnn",' 
          write(nu_out(i),'(a)') 
     :   '! the notation for the non-geometric mean, '//
     :   'orientation-independent PSA is "rotdnn", rather than the '
          write(nu_out(i),'(a)') 
     :   '! more logical "psa_rotdnn".  The paper that introduced '//
     :   'rotdnn (Boore, BSSA 2010) also introduced rotinn, '
          write(nu_out(i),'(a)')
     :   '! which is akin to gmrotinn; that paper recommended '//
     :   ' against its use, however, and therefore it is not'
          write(nu_out(i),'(a)')
     :   '! one of the seismic intensity measures provided by this '//
     :      'program.'
          write(nu_out(i),'(a)')
     :   '!'
          write(nu_out(i),'(a)')
     :   '! Also note that psa is computed for all periods '//
     :   'specified in the control file, even IF they are beyond'
          write(nu_out(i),'(a)')
     :   '! what one would consider to be the maximum usable period '//
     :   'based on considerations of the low-cut filter frequencies.'
          write(nu_out(i),'(a)')
     :   '! It is up to the user to decide what periods to use in '//
     :   'an analysis.'
          write(nu_out(i),'(a)')
     :   '!'
          write(nu_out(i),'(a)')
     :   '! I added rotd50ang1 and rotd50ang2 as outputs'//
     :   ' on 03 February 2018.' 
          write(nu_out(i),'(a)')
     :   '! Note that in the program an even number of ground-motion'//
     :   ' intensity'
          write(nu_out(i),'(a)')
     :   '! measures (GMIMs) are computed for rotation angles from 0'//
     :   ' degrees to 180 minus the rotation angle increment.'  
          write(nu_out(i),'(a)')
     :   '! Because of the even number of GMIMs, the median'//
     :   ' (50th percentile) value (RotD50) comes from an average'
          write(nu_out(i),'(a)')
     :   '! of two values, which usually have very different rotation'//
     :   ' angles. For this reason I did not provide values of '
          write(nu_out(i),'(a)')
     :   '! rotd50ang in previous versions of the program.  I'//
     :   ' realized, however, that some users might want to rotate'
          write(nu_out(i),'(a)')
     :   '! the original time series in order to obtain a time'//
     :   ' series with a GMIM close to RotD50 for a particular period.'
          write(nu_out(i),'(a)')
     :   '! For that use, the angles that the program writes to the'//
     :   ' output file correspond to the GMIM on either side of RotD50' 
          write(nu_out(i),'(a)')
     :   '! (indices 90 and 91 when sorted by value and the angle'//
     :   ' increment is 1 degree).'
          write(nu_out(i),'(a)')
     :   '!'
       
          IF (output_in_gals) THEN
            write(nu_out(i),'(a)') 
     :     '! Units of acceleration (psa and pga) and velocity are '//
     :        'cm/s/s and cm/s, respectively.'
            write(nu_out(i),'(a)')
     :        '!'
          ELSE
            write(nu_out(i),'(a)') 
     :     '! Units of acceleration (psa and pga) and velocity are '//
     :        'g and cm/s, respectively.'
            write(nu_out(i),'(a)')
     :        '!'
          END IF
          
          write(nu_out(i),'(
     :      65x,a,
     :      1x,65x,a,
     :      1x,a, 1x,a,
     :      3x,a, 1x,a,
     :      3x,a, 1x,a,
     :      1x,a, 
     :      1x,a,
     :      3x,a, 3x,a, 3x,a,
     A    1x,a,
     :      2x,a, 2x,a,
     :      1x,a, 1x,a,
     :      3x,a, 1x,a,
     :      4x,a, 4x,a,
     :      1x,a,
     :      4x,a, 4x,a,
     :      1x,a,
     :      4x,a, 4x,a,
     :      1x,a,
     :      3x,a, 3x,a, 3x,a,
     B      1x,a, 1x,a, 1x,a, 1x,a,
     :      3x,a, 3x,a, 3x,a,
     :      1x,a, 1x,a, 1x,a, 1x,a,
     :      3x,a, 3x,a, 3x,a,
     :      1x,a, 1x,a, 1x,a, 1x,a,
     :      2x,a,
     :   200(1x,a9,
     :       1x,a,
     :       6x,a, 6x,a,
     :       5x,a, 5x,a, 
     :       7x,a, 1x,a, 
     :                     5x,a, 
     :       7x,a, 7x,a, 6x,a, 
     :       1x,a, 1x,a, 1x,a, 1x,a)
     :                             )') 
     :     'file1', 
     :     'file2',
     :     'log(npts1)', 'log(npts2)',
     :     'flc1', 'nslope1',
     :     'flc2', 'nslope2',
     :     'tmax4penalty',
     :     'units_acc_vel',
     :     'pga_gmroti50', 'pgv_gmroti50', 'pgd_gmroti50',
     A   'gmroti50angle',
     :     'pga_gmrot50',  'pgv_gmrot50',
     :     'pga_gmrot100', 'pgagmrotang100',
     :     'pgv_gmrot100', 'pgvgmrotang100',
     :     'pga_1_ar', 'pga_2_ar',
     :     'log(n_a_subset)',
     :     'pgv_1_ar', 'pgv_2_ar',
     :     'log(n_v_subset)',
     :     'pgd_1_ar', 'pgd_2_ar',
     :     'log(n_d_subset)',
     :     'pga_rot00',   'pga_rot50', 'pga_rot100', 
     B     'pgarot00ang', 'pgarot50ang1','pgarot50ang2','pgarot100ang',
     :     'pgv_rot00',   'pgv_rot50', 'pgv_rot100', 
     :     'pgvrot00ang', 'pgvrot50ang1','pgvrot50ang2','pgvrot100ang',
     :     'pgd_rot00',   'pgd_rot50', 'pgd_rot100', 
     :     'pgdrot00ang', 'pgdrot50ang1','pgdrot50ang1','pgdrot100ang',
     :     'damp',
     :     (colhead(iper),
     :      'log(npts_subset)',
     :      'aa_1_ar', 'aa_2_ar', 
     :      'psa_1_ar', 'psa_2_ar',
     :      'psa_gm_ar', 'psa_larger_ar', 
     :                        'gmroti50',
     :      'rotd00',    'rotd50', 'rotd100',   
     :      'rotd00ang', 'rotd50ang1', 'rotd50ang2', 'rotd100ang',
     :                        iper = 1, nper_max)


        
 
        END DO LOOP1 OVER DAMP
        
      END IF   ! .not. output_separate_files
         
      call skipcmnt(nu_ctl,cmnts2skip,nc_cmnts2skip)
      
      call timer_subroutine(time_start_all_files)
      
! ##########################  BEGIN LOOP OVER INPUT FILES #####################

      nrecs = 0

      BIG LOOP OVER INPUT FILES: DO

        print *,''
        print *,' ****** PROCESSING A NEW PAIR OF FILES ******'

        write(nu_sum,*)
        write(nu_sum,'(a)') 
     :          ' ****** PROCESSING A NEW PAIR OF FILES ******'
        write(nu_sum,*)

! First get max dimension and allocate arrays:
        DO j = 1, 2
          buf = ' '
          read(nu_ctl,'(a)') buf
          call trim_c(buf,nc_buf)
          print *,' buf = '//buf(1:nc_buf)
          buf4 = ' '
          buf4 = buf(1:4)
          call upstr(buf4)

          IF (buf4(1:4) == 'STOP') THEN
            write(*, '(a)') 
     :           ' buf = '//buf(1:nc_buf)//'; QUITTING' 
            EXIT BIG LOOP OVER INPUT FILES
          END IF  ! terminate on reaching "STOP"

          f_in(j) = ' '
          f_in(j) = buf(1:nc_buf)
          call trim_c(f_in(j), nc_f_in(j))
          f_exist = .false.
          INQUIRE(file=f_in(j)(1:nc_f_in(j)), exist=f_exist)
          IF (.not. f_exist) THEN
            write(nu_sum,'(a)') ' ******* FILE '//
     :                         f_in(j)(1:nc_f_in(j))//
     :                        ' DOES NOT EXIST: QUIT! ******* '
            EXIT BIG LOOP OVER INPUT FILES
          END IF
          
          write(nu_sum,'(a,i1,a)') 
     :                 ' f_in(',j,') = '//f_in(j)(1:nc_f_in(j))
          write(*,'(a,i1,a)') 
     :                 ' f_in(',j,') = '//f_in(j)(1:nc_f_in(j))

          call smc_npts(f_in(j)(1:nc_f_in(j)), npts_in(j), sps_in(j))
          
        END DO  ! end reading of two files from control file
        
        call timer_subroutine(time_start_one_file)    
        
        max_dimen_in = max0( npts_in(1), npts_in(2) )
        allocate( a_in(max_dimen_in,2) )
        
        npts(1) = interpolate_factor * npts_in(1)
        npts(2) = interpolate_factor * npts_in(2)

        max_dimen = max0( npts(1), npts(2) )
        allocate( a_in_interp(max_dimen,2), a_out(max_dimen,2) )


! Second, loop over the two horizontal component input files, reading data:
        DO j = 1, 2
        
          call SMCRead(f_in(j)(1:nc_f_in(j)), 0.0, 100000.0,
     :                 a_in(1,j), char_head(1,j), 
     :                 int_head(1,j), real_head(1,j), 
     :                 comments(1,j))

          npts_in(j)  = int_head(17,j)  ! should check equality of both time series
          rnull(j) = real_head(1,j)
          inull(j) = int_head(1,j)
          azm_in(j) = real(int_head(14,j)) 
          IF (real_head(33,j) == rnull(j)) THEN
            flc(j) = -9.9
          ELSE
            flc(j) = real_head(33,j)
          END IF
          IF (real_head(34,j) == rnull(j)) THEN
            nslope(j) = -9
          ELSE
            nslope(j) = 4*int(abs(real_head(34,j)))  ! assume acausal
          END IF

! Scale to cm/s/s if in g:
        if (accel_units_g) then
          do i = 1, npts_in(j)
            a_in(i,j) = g2gals * a_in(i,j)
          end do
        end if
        
!          IF (j == 1) THEN   ! overwrite any existing azimuth in the header with 0 and 90
!            azm_in(j) = 0.0
!          ELSE
!            azm_in(j) = 90.0
!          END IF
          

        END DO ! loop over reading data for the two components 

!Resample input acceleration time series

      DO j = 1, 2

        call interpolate_time_series_using_fork(
     :    a_in(1,j), sps_in(j), npts_in(j), 
     :    interpolate_factor,
     :    a_in_interp(1,j), sps(j), npts(j) )
     
      END DO

      deallocate ( a_in )
      
! ############ BEGIN CONSISTENCY CHECKS  #################################
!
! Begin work with azimuths:
!
        IF (azm_in(1) == real(inull(1)) .or. 
     :      azm_in(1) == real(inull(1))       ) THEN    ! Use inull rather than rnull because 
                                                        ! the azimuths are stored in the
                                                        ! integer headers
          azm_in(1) = 0.0
          azm_in(2) = 90.0
        ELSE
! Revision on 01/31/12:  If the azimuths are not null, I assume they are
! correct in the smc files.  
! First: check if the azimuths are 90 degrees apart(I moved this here on 09/23/12 from
! latter in the program).
! Secpnd: check to see IF 
! azm_in(2) = azm_in(1) + 90 or azm_in(2) = azm_in(1) - 90.  If the latter is the case,
! switch components 1 and 2 so that the rotation angles for
! rotd00 and rotd100 are correct (they are relative to the azimuth of component 1).

! Check for azimuths being 90 degrees apart (compute the dot product):
          dot = cos(d2r*azm_in(1))*cos(d2r*azm_in(2))+
     :          sin(d2r*azm_in(1))*sin(d2r*azm_in(2))
          eps = 0.001
          IF (abs(dot) > eps) THEN
          
            print*, 
     :        '  H1, H2 are not 90 degrees apart '//
     :        '(dot product of unit vectors not 0.0); see SUM file'//
     :        ' for details; SKIPPING THIS PAIR OF FILES!!!'
     
            write(nu_sum,'(a)') 
     :        '  H1, H2 are not 90 degrees apart '//
     :        '(dot product of unit vectors not 0.0)'
            write(nu_sum,'(a, 1x,f6.1, 1x,f6.1, 1x,es10.3)') 
     :         '  azm_in(1,2), dot = ',
     :            azm_in(1), azm_in(2), dot
     
            deallocate( a_in_interp, a_out)

            CYCLE BIG LOOP OVER INPUT FILES
          END IF

! Check for order of azimuths
          dot = cos(d2r*(azm_in(1)+90))*cos(d2r*azm_in(2))+
     :        sin(d2r*(azm_in(1)+90))*sin(d2r*azm_in(2))
          IF ( dot < 0) THEN !  azm2 = azm1-90.0, switch order of all variable and the filenames
            temp_f_in = ' '
            temp_f_in = f_in(1)(1:nc_f_in(1))
            f_in(1) = ' '
            f_in(1) = f_in(2)(1:nc_f_in(2))
            f_in(2) = ' '
            f_in(2) = temp_f_in
            DO j = 1, 2
              call trim_c(f_in(j), nc_f_in(j))
            END DO
            rnulldum = rnull(1)
            rnull(1) = rnull(2)
            rnull(2) = rnulldum
            inulldum = inull(1)
            inull(1) = inull(2)
            inull(2) = inulldum
            azmdum    = azm_in(1)
            azm_in(1) = azm_in(2)
            azm_in(2) = azmdum
            flcdum    = flc(1)
            flc(1)    = flc(2)
            flc(2)    = flcdum
            nslopedum = nslope(1)
            nslope(1) = nslope(2)
            nslope(2) = nslopedum
            allocate( temp_a_in(max_dimen) )
            DO i = 1, npts(1)
              temp_a_in(i) = a_in_interp(i,1)
            END DO
            DO i = 1, npts(2)
              a_in_interp(i,1) = a_in_interp(i,2)
            END DO
            DO i = 1, npts(1)
              a_in_interp(i,2) = temp_a_in(i) 
            END DO
            deallocate( temp_a_in )
            ndum = npts(1)
            npts(1) = npts(2)
            npts(2) = ndum
          END IF        
        
        END IF  
!        
! End work with azimuths
        
! Check for equality of sps:
        IF ( sps(1) /= sps(2)) THEN
        
            print *, 
     :      ' SKIPPING THIS PAIR OF FILES: sps1 /= sps2; sps1, sps2 = ', 
     :        sps(1), sps(2)
     
            write(nu_sum,'(a,1p, 2(1x,e12.5))') 
     :      ' SKIPPING: sps1 /= sps2; sps1, sps2 = ', 
     :        sps(1), sps(2)
     
          deallocate( a_in_interp, a_out)

          CYCLE BIG LOOP OVER INPUT FILES
        END IF
        
! Check for equality of npts:
        IF ( iabs(npts(1) - npts(2)) > npts_skip) THEN
        
            print *, 
     :      ' SKIPPING THIS PAIR OF FILES: iabs(npts1 - npts2) > '//
     :      'npts_skip; npts1, npts2, npts_skip = ', 
     :        npts(1), npts(2), npts_skip
     
            write(nu_sum,'(a,3(1x,i8))') 
     :      ' SKIPPING: iabs(npts1 - npts2) > '//
     :      'npts_skip; npts1, npts2, npts_skip = ', 
     :        npts(1), npts(2), npts_skip
     
          deallocate( a_in_interp, a_out)
          
          CYCLE BIG LOOP OVER INPUT FILES
        END IF
! 
! ############ END CONSISTENCY CHECKS  #################################

! Passed all consistency tests.

        nrecs = nrecs + 1
      
! find max period corresponding to the low-cut filter frequencies:
!
        IF (flc(1) < 0.0 .or. flc(2) < 0.0) THEN
          f_max_flc1_flc2 = -9.0 
          t_min_flc1_flc2 = -9.0
          tusable = -9.0
        ELSE
          f_max_flc1_flc2 = amax1(flc(1),flc(2)) 
          if (f_max_flc1_flc2 == 0.0) then
            t_min_flc1_flc2 = 999.99  ! No low-cut filter
            tusable = 999.99
          else          
            t_min_flc1_flc2 = 1.0/f_max_flc1_flc2
            tusable = t_min_flc1_flc2/fusable_div_flc
          end if
        END IF
       
        write(nu_sum,'(a,5(1x,es11.4) )') 
     :     ' For '//f_in(1)(1:nc_f_in(1))//
     :     ', flc(1), flc(2), f_max_flc1_flc2, t_min_flc1_flc2, '//
     :     ' tusable = ', 
     :        flc(1), flc(2), f_max_flc1_flc2, t_min_flc1_flc2,
     :        tusable
        
! Check IF need to reset tmax4penalty

        tmax4penalty_b4reset = tmax4penalty
        IF (use_flc4tmax4penalty .and. tusable > 0.0) THEN
          IF (tusable < period(nper_max) ) THEN
            DO i = 1, nper_max
              IF (period(i) > tusable) THEN
                nper4penalty = i-1
                tmax4penalty = period(nper4penalty)
                write(nu_sum,'(a, 1x,l1, 
     :                         1x,i8, 1x,f7.4, 1x,es11.4,
     :                         1x,f5.1, 1x,f5.1, 
     :                         1x,i8)') 
     :          ' Reset tmax4penalty: use_flc4tmax4penalty, '//
     :           'nper_max, period(nper_max), tusable, '//
     :           'tmax4penalty_b4reset, tmax4penalty, '//
     :           'nper4penalty = ', 
     :            use_flc4tmax4penalty, 
     :            nper_max, period(nper_max), tusable, 
     :            tmax4penalty_b4reset, tmax4penalty, 
     :            nper4penalty            
                EXIT   
              END IF
            END DO
          ELSE
            write(nu_sum,'(a)') ' use_flc4tmax4penalty = T and '//
     :      'flc specified, but tusable > period(nper_max) '//
     :      'so tmax4penalty is not reset.'
            write(nu_sum,'(a, 1x,es11.4, 1x,f7.4, 1x,f7.4 )') 
     :      '   tusable, period(nper_max), tmax4penalty = ',   
     :          tusable, period(nper_max), tmax4penalty    
          END IF
        END IF

        IF (use_flc4tmax4penalty .and. tusable <= 0.0) THEN
            write(nu_sum,'(a)') ' use_flc4tmax4penalty = T, but '//
     :      'flc not specified, so tmax4penalty is not reset using flc'
        END IF        
        
        write(nu_sum,*)
        write(nu_sum, '(a, 1x,i8, 1x,f7.4,
     :                     1x,i8, 1x,f7.4)') 
     :    ' The final values of nper_max, period(nper_max), '//
     :      'nper4penalty, and tmax4penalty = ',
     :       nper_max, period(nper_max),  
     :       nper4penalty, tmax4penalty 
        write(nu_sum,*)

        
! Step: Remove a mean from the whole record

!  Determine the appropriate mean:
        DO j = 1, 2
          t4mean = t4mean_in
          IF (t4mean < 0.0) THEN  ! DO not remove a mean
            avg = 0.0
          ELSE
            tend = float(npts(j)-1)/sps(j)
            IF (t4mean == 0.0 .or. t4mean > tend) THEN   
              t4mean = tend  ! use whole record
            END IF
          END IF
          n_t4mean = sps(j) * t4mean + 1.1
          cum_avg = 0.0
          DO i = 1, n_t4mean
            cum_avg = cum_avg + dble(a_in_interp(i,j))
          END DO
          avg = cum_avg/float(n_t4mean)
!          avg = sngl(cum_avg/n_t4mean)
!  Remove the mean from the whole record:
          DO i = 1, npts(j)
            a_in_interp(i,j) = a_in_interp(i,j) - avg
          END DO
        END DO   ! remove means from both components
 
! set min_dimen (used in selecting subsets for rotations) 
! to minimum value of the npts for each time series.
! If min_dimen is not set to the
! minimum value, the subsets could have some 
! mystery values IF it exceeds the actual
! length of the jth time series.

        min_dimen = min0(npts(1), npts(2)) 
          
        write(nu_sum,'(a, 1x,i8, 1x,i8, 1x,i8)') 
     :      ' npts(1), npts(2), min_dimen = ',          
     :        npts(1), npts(2), min_dimen
     

! ############## BEGIN MAIN PART OF ANALYSIS ##################################

! Program structure (to avoid carrying along large multidimensioned arrays):
!
!     PGA, PGV, PGD:
!       compute vel, dis
!       select subset
!       loop over rotation angles
!         find PGA, PGV, PGD values
!       end loop over rotation angles
!       
!     RS:
!       loop over damping
!         loop over period
!           compute as recorded rd, rv, aa, store time series with rd
!           select subset
!           loop over rotation angles
!             compute RD values
!           end loop over rotation angles
!           sort, find n=00, 50, 100 values
!         end loop over period
!         write output file for this damping (including PGA, PGV, PGD, as-recorded values)
!       end loop over damping
!       sort, find n=00, 50, 100 values
!   END BIG LOOP OVER INPUT FILES

!  ^^^^^^^^^^^^^^^^^^^^^^ START OF SECTION FOR PGA, PGV, PGD  ^^^^^^^^^^^^^^^^^^^^^^^^^^
!
!COMPUTE AS-RECORDED VEL, DIS

        allocate( vel(max_dimen, 2), dis(max_dimen, 2) )

        v0 = 0.0
        d0 = 0.0
        rmv_trnd = .false.
        
        dt = 1.0/sps(1)    ! Previously made sure that sps(1) = sps(2)

        vel = 0.0
        dis = 0.0

        DO j = 1, 2
          
          call acc2vd( a_in_interp(1,j), npts(j), dt, rmv_trnd, 
     :          v0, d0, vel(1,j), dis(1,j) )
     
          call abs_mnmaxidx(dis(1,j), 1, npts(j), 1,
     :          vmin, vmax, indxpgv_min, indxpgv_max, pgd(j)) 

          call abs_mnmaxidx(vel(1,j), 1, npts(j), 1,
     :          vmin, vmax, indxpgv_min, indxpgv_max, pgv(j)) 

          call abs_mnmaxidx(a_in_interp(1,j), 1, npts(j), 1,
     :          amin, amax, indxpga_min, indxpga_max, pga(j))
   
        END DO
     
!STORE AS-RECORDED VALUES:

        pgd_1_ar  = pgd(1)
        pgd_2_ar  = pgd(2)
        
        pgv_1_ar  = pgv(1)
        pgv_2_ar  = pgv(2)
        pgv_gm_ar = sqrt(pgv_1_ar*pgv_2_ar)
        IF (pgv_1_ar > pgv_2_ar) THEN
          pgv_larger_ar = pgv_1_ar 
        ELSE
          pgv_larger_ar = pgv_2_ar 
        END IF
        
        pga_1_ar  = pga(1)
        pga_2_ar  = pga(2)
        pga_gm_ar = sqrt(pga_1_ar*pga_2_ar)
        IF (pga_1_ar > pga_2_ar) THEN
          pga_larger_ar = pga_1_ar 
        ELSE
          pga_larger_ar = pga_2_ar 
        END IF
        
!SELECT SUBSETS:     
     
     
        allocate( a_subset(min_dimen,2), 
     :            v_subset(min_dimen,2), 
     :            d_subset(min_dimen,2),
     :            t_subset(min_dimen)   )


        call select_subsets_for_rotations(
     :  a_in_interp(1,1), a_in_interp(1,2), min_dimen, dt, 
     :  fraction4subset_selection,
     :  a_subset(1,1), a_subset(1,2), t_subset, n_a_subset,
     :  alevel_a)

        call select_subsets_for_rotations(
     :  vel(1,1), vel(1,2), min_dimen, dt, fraction4subset_selection,
     :  v_subset(1,1), v_subset(1,2), t_subset, n_v_subset,
     :  alevel_v)

        call select_subsets_for_rotations(
     :  dis(1,1), dis(1,2), min_dimen, dt, fraction4subset_selection,
     :  d_subset(1,1), d_subset(1,2), t_subset, n_d_subset,
     :  alevel_d)

        deallocate( vel, dis, t_subset )

!LOOP OVER ROTATION ANGLES:

        allocate ( a4rot(n_a_subset,2), v4rot(n_v_subset,2), 
     :             d4rot(n_d_subset,2) )   

        ROT FOR PGA PGV PGD: DO iz = 1, nrot90
      
          rot_angle4gmrot(iz) = float(iz-1)*d_rot_angle   ! note: iz = 1 corresponds to no rotation
          rot_angle4rot(2*(iz-1)+1) = rot_angle4gmrot(iz)
          rot_angle4rot(2*(iz-1)+2) = rot_angle4gmrot(iz) + 90.0  
       
          a4rot = 0.0
          v4rot = 0.0
          d4rot = 0.0
          
          DO j = 1, 2
            DO i = 1, n_a_subset
              a4rot(i,j) = a_subset(i,j)
            END DO
            DO i = 1, n_v_subset
              v4rot(i,j) = v_subset(i,j)
            END DO
            DO i = 1, n_d_subset
              d4rot(i,j) = d_subset(i,j)
            END DO
          END DO
 
!          azm1 = azm_in(1)   ! azm_in is specified in the loop in which the two input files are read.
!          azm2 = azm_in(2)
          azm1 = 0.0
          azm2 = 90.0    ! the order of azimuths has been constrained such that azm2 = azm1+ 90; specify
                         ! azm1 = 0.0 here so that the rotation angles are relative to 
                         ! the azimuth of component 1 (I can see changing this so that the azimuth
                         ! of rotd00 and rotd100 are actual azimuth relative to N, but that
                         ! is a possible option for a future version).
          znull = 1.7000000E+38

          call Rotate( a4rot(1,1), a4rot(1,2),
     :         znull,
     :         azm1, azm2, rot_angle4gmrot(iz), n_a_subset)
     
          azm1 = 0.0         ! Note: azm1, azm2 on output are the new azimuth and that azimuth + 90,
                             ! so azm1 and azm2 need to be reinitialized before each call to Rotate.
                             ! Not doing so led to a hard-to-find bug in the program.
          azm2 = 90.0
          call Rotate( v4rot(1,1), v4rot(1,2),
     :         znull,
     :         azm1, azm2, rot_angle4gmrot(iz), n_v_subset)

          azm1 = 0.0
          azm2 = 90.0
          call Rotate( d4rot(1,1), d4rot(1,2),
     :         znull,
     :         azm1, azm2, rot_angle4gmrot(iz), n_d_subset)
     
          GET_PGA_PGV_PGD: DO j = 1, 2
      
            call abs_mnmaxidx(a4rot(1,j), 1, n_a_subset, 1,
     :          amin, amax, indxpga_min, indxpga_max, pga(j))

            call abs_mnmaxidx(v4rot(1,j), 1, n_v_subset, 1,
     :          vmin, vmax, indxpgv_min, indxpgv_max, pgv(j))

            call abs_mnmaxidx(d4rot(1,j), 1, n_d_subset, 1,
     :          dmin, dmax, indxpgd_min, indxpgd_max, pgd(j))

            pga_rot180(2*(iz-1)+j) = pga(j)
            pgv_rot180(2*(iz-1)+j) = pgv(j)
            pgd_rot180(2*(iz-1)+j) = pgd(j)
            
          END DO GET_PGA_PGV_PGD
 
          pga_gmrot(iz) = sqrt(pga(1)*pga(2))
          pgv_gmrot(iz) = sqrt(pgv(1)*pgv(2))
          pgd_gmrot(iz) = sqrt(pgd(1)*pgd(2))
            
        END DO ROT FOR PGA PGV PGD
            
        deallocate ( a4rot, v4rot, d4rot )
        deallocate ( a_subset, v_subset, d_subset )

!  ^^^^^^^^^^^^^^^^^^^^^^ END OF SECTION FOR PGA, PGV, PGD  ^^^^^^^^^^^^^^^^^^^^^^^^^^


!  ^^^^^^^^^^^^^^^^^^^^^^ BEGIN SECTION FOR RD  ^^^^^^^^^^^^^^^^^^^^^^^^^^

!LOOP OVER DAMPING
        BIG LOOP OVER DAMPING: DO idamp = 1, ndamp

            damp4rscalc = damp(idamp)

!LOOP OVER PERIOD
          BIG LOOP OVER PERIOD: DO iper = 1, nper_max
          
!COMPUTE AS-RECORDED RD, RV, AA, AND RD OSCILLATOR TIME SERIES:

            allocate( rd_ar_ts(max_dimen, 2), dum_rv(max_dimen) )

            omega = twopi/period(iper)
            omega2 = omega**2
            v0 = 0.0
            d0 = 0.0
            rmv_trnd = .false.
            dt = 1.0/sps(1)    ! Previously made sure that sps(1) = sps(2)

            rd_ar_ts = 0.0
            dum_rv = 0.0
            
            DO j = 1, 2
 
              call rdrvaa_rd_rv_ts(
     :            a_in_interp(1,j), npts(j), omega, damp(idamp), dt,
     :            rd_ar(j), rv_ar(j), aa_ar(j), d0, v0, 
     :            rd_ar_ts(1,j), dum_rv )
            
            END DO
            
!STORE AS-RECORDED VALUES:

            rd_1_ar(iper, idamp) = rd_ar(1)
            rd_2_ar(iper, idamp) = rd_ar(2)
             
            rv_1_ar(iper, idamp) = rv_ar(1)
            rv_2_ar(iper, idamp) = rv_ar(2)
             
            aa_1_ar(iper, idamp) = aa_ar(1)
            aa_2_ar(iper, idamp) = aa_ar(2)
             
            psv_1_ar(iper, idamp) = omega*rd_ar(1)
            psv_2_ar(iper, idamp) = omega*rd_ar(2)

            psa_1_ar(iper, idamp) = omega2*rd_ar(1)
            psa_2_ar(iper, idamp) = omega2*rd_ar(2)
             
            psa_gm_ar(iper, idamp) = 
     :        sqrt(psa_1_ar(iper, idamp)*psa_2_ar(iper, idamp))
            IF (psa_1_ar(iper, idamp) > psa_2_ar(iper, idamp)) THEN
              psa_larger_ar(iper, idamp) = psa_1_ar(iper, idamp)
            ELSE
              psa_larger_ar(iper, idamp) = psa_2_ar(iper, idamp)
            END IF

!SELECT SUBSETS:     
     
     
            allocate( rd_subset(min_dimen,2), 
     :            t_subset(min_dimen)   )


            call select_subsets_for_rotations(
     :        rd_ar_ts(1,1), rd_ar_ts(1,2), min_dimen, dt, 
     :        fraction4subset_selection,
     :        rd_subset(1,1), rd_subset(1,2), t_subset, 
     :        n_rd_subset(iper, idamp), 
     :        alevel_rs)


            deallocate( rd_ar_ts, dum_rv, t_subset )

            allocate ( rd4rot(n_rd_subset(iper, idamp),2) )   

            ROT FOR RD: DO iz = 1, nrot90
      
              rot_angle4gmrot(iz) = float(iz-1)*d_rot_angle   ! note: iz = 1 corresponds to no rotation
              rot_angle4rot(2*(iz-1)+1) = rot_angle4gmrot(iz)
              rot_angle4rot(2*(iz-1)+2) = rot_angle4gmrot(iz) + 90.0  
       
              rd4rot = 0.0
           
              DO j = 1, 2
                DO i = 1, n_rd_subset(iper, idamp)
                  rd4rot(i,j) = rd_subset(i,j)
                END DO
              END DO
 
!              azm1 = azm_in(1)   ! azm_in is specified in the loop in which the two input files are read.
!              azm2 = azm_in(2)
              azm1 = 0.0
              azm2 = 90.0    ! the order of azimuths has been constrained such that azm2 = azm1+ 90; specify
                         ! azm1 = 0.0 here so that the rotation angles are relative to 
                         ! the azimuth of component 1 (I can see changing this so that the azimuth
                         ! of rotd00 and rotd100 are actual azimuth relative to N, but that
                         ! is a possible option for a future version).
              znull = 1.7000000E+38

              call Rotate( rd4rot(1,1), rd4rot(1,2),
     :         znull, azm1, azm2, rot_angle4gmrot(iz),
     :              n_rd_subset(iper, idamp)               )
      
              GET_RD: DO j = 1, 2
      
                call abs_mnmaxidx(rd4rot(1,j),
     :          1, n_rd_subset(iper, idamp), 1,
     :          rdmin, rdmax, indxrd_min, indxrd_max, rd(j))
                 
                psa(j) = omega2 * rd(j) 
              
                psa_rot180(2*(iz-1)+j,iper, idamp) = psa(j)

              END DO GET_RD
 
              gmean(iz, iper, idamp) = sqrt(psa(1) * psa(2))
          
            
            END DO ROT FOR RD
            
            deallocate ( rd4rot )
            deallocate ( rd_subset )

          END DO BIG LOOP OVER PERIOD 
          
        END DO BIG LOOP OVER DAMPING
 
!  ^^^^^^^^^^^^^^^^^^^^^^ END SECTION FOR RD  ^^^^^^^^^^^^^^^^^^^^^^^^^^


!  ^^^^^^^^^^^BEGIN SECTION FOR SORTING AND OBTAINING INTENSTIY MEASURES  ^^^^^              
 
! Get pga, pgv over rotations

        call get_00_50_100_values(pga_rot180, n_rot180, 
     :         pga_rot00, pga_rot50, pga_rot100,
     :         index_n00, index_1_n50, index_2_n50, index_n100)
        pgarot00ang = rot_angle4rot(index_n00)
        pgarot50ang1 = rot_angle4rot(index_1_n50)
        pgarot50ang2 = rot_angle4rot(index_2_n50)
        pgarot100ang = rot_angle4rot(index_n100)

        call get_00_50_100_values(pgv_rot180, n_rot180, 
     :         pgv_rot00, pgv_rot50, pgv_rot100,
     :         index_n00, index_1_n50, index_2_n50, index_n100)
        pgvrot00ang = rot_angle4rot(index_n00)
        pgvrot50ang1 = rot_angle4rot(index_1_n50)
        pgvrot50ang2 = rot_angle4rot(index_2_n50)
        pgvrot100ang = rot_angle4rot(index_n100)

        call get_00_50_100_values(pgd_rot180, n_rot180, 
     :         pgd_rot00, pgd_rot50, pgd_rot100,
     :         index_n00, index_1_n50, index_2_n50, index_n100)
        pgdrot00ang = rot_angle4rot(index_n00)
        pgdrot50ang1 = rot_angle4rot(index_1_n50)
        pgdrot50ang2 = rot_angle4rot(index_2_n50)
        pgdrot100ang = rot_angle4rot(index_n100)


        call get_00_50_100_values(pga_gmrot, nrot90, 
     :         pga_gmrot00, pga_gmrot50, pga_gmrot100,
     :         index_n00, index_1_n50, index_2_n50, index_n100)
        pgagmrot100ang = rot_angle4gmrot(index_n100)
     
        call get_00_50_100_values(pgv_gmrot, nrot90, 
     :         pgv_gmrot00, pgv_gmrot50, pgv_gmrot100,
     :         index_n00, index_1_n50, index_2_n50, index_n100)
        pgvgmrot100ang = rot_angle4gmrot(index_n100)

        call get_00_50_100_values(pgd_gmrot, nrot90, 
     :         pgd_gmrot00, pgd_gmrot50, pgd_gmrot100,
     :         index_n00, index_1_n50, index_1_n50, index_n100)
        pgdgmrot100ang = rot_angle4gmrot(index_n100)

! Get PSA measures

        LOOP OVER DAMPINGS: DO idamp = 1, ndamp

          DO iper = 1, nper_max
      
            work = 0.0

            DO iz = 1, nrot90
              work(iz) =  gmean(iz, iper, idamp)
            END DO
      
            call get_00_50_100_values(work, nrot90, 
     :         gmrotd00(iper, idamp), gmrotd50(iper, idamp), 
     :         gmrotd100(iper, idamp),
     :         index_n00, index_1_n50, index_2_n50, index_n100)
     
            gmrotd00ang(iper, idamp) = rot_angle4gmrot(index_n00)
            gmrotd100ang(iper, idamp) = rot_angle4gmrot(index_n100)

            call get_00_50_100_values(psa_rot180(1, iper, idamp), 
     :         n_rot180, 
     :         rotd00(iper, idamp), rotd50(iper, idamp), 
     :         rotd100(iper, idamp),
     :         index_n00, index_1_n50, index_2_n50, index_n100)

            rotd00ang(iper, idamp) = rot_angle4rot(index_n00)
            rotd50ang1(iper, idamp) = rot_angle4rot(index_1_n50)
            rotd50ang2(iper, idamp) = rot_angle4rot(index_2_n50)
            rotd100ang(iper, idamp) = rot_angle4rot(index_n100)

! NOTE: because rotd50 is determined as the average of two values of index_rot180 (because 
! the number of rotation angles is even), there is no unique angle (rotd50ang) for rotd50.
! The same comment applies to gmrotd50.   
          
          END DO  ! end loop over nper_max
          
        END DO  LOOP OVER DAMPINGS
        
! DO PERIOD-INDEPENDENT CALCULATIONS FOR GMROTI50:

        write(nu_sum,*)
        write(nu_sum,*) ' nper_max, nper4penalty = ', 
     :                    nper_max, nper4penalty
        write(nu_sum,*)

        BIG LOOP2 OVER DAMPING: DO idamp = 1, ndamp

          DO iz = 1, nrot90
        
            penalty(iz) = 0.0
          
            DO iper = 1, nper4penalty
              gmrot_norm(iz, iper) = 
     :             gmean(iz,iper, idamp)/gmrotd50(iper,idamp)
              penalty(iz) = penalty(iz) + 
     :                   (gmrot_norm(iz,iper) - 1)**2
            END DO
          
            penalty(iz) = penalty(iz)/real(nper4penalty)
            
          END DO
          
! Find minimum        
          call mnmaxidx(penalty,1,nrot90,1,
     :      penalty_min,penalty_max,indx_min4gmrot,indx_max4gmrot) 
     
          write(nu_sum,'(a,1x,i8, 1x,f7.2,1p,1x,e10.3)')     
     :    ' For GMRot: indx_min, rot_angle_min, penalty_min = ', 
     :      indx_min4gmrot, 
     :      rot_angle4gmrot(indx_min4gmrot), penalty_min 
     
          DO iper = 1, nper_max
            gmroti50(iper, idamp) = gmean(indx_min4gmrot,iper, idamp)
          END DO
        
          gmroti50angle(idamp) = rot_angle4gmrot(indx_min4gmrot)
        
! Rotate into minimum azimuth for computation of pga and pgv:
          DO j = 1, 2
            write(nu_sum,'(a,i1,a,1x,i8)') ' npts(',j,') = ', npts(j)
            DO i = 1, npts(j)
              a_out(i,j) = a_in_interp(i,j)
            END DO
          END DO

          azm1 = azm_in(1)   ! azm_in is specified in the loop in which the two input files are read.
          azm2 = azm_in(2)
          znull = 1.7000000E+38
          call Rotate(a_out(1,1),a_out(1,2),znull,
     :    azm1,azm2,gmroti50angle(idamp),min_dimen) !22sep12
     
! Get peak motions:

          allocate( vel4gmroti(max_dimen), dis4gmroti(max_dimen) )
        
          dt = 1.0/sps(1)    ! Previously made sure that sps(1) = sps(2)
          v0 = 0.0
          d0 = 0.0
          rmv_trnd = .false.
          vel4gmroti = 0.0
          dis4gmroti = 0.0

          DO j=1, 2
          
            call acc2vd(a_out(1,j), npts(j), dt, rmv_trnd, 
     :         v0, d0, vel4gmroti, dis4gmroti)
     
            call abs_mnmaxidx(a_out(1,j), 1, npts(j), 1,
     :       amin, amax, indxpga_min, indxpga_max, pga(j)) 
            call abs_mnmaxidx(vel4gmroti, 1, npts(j), 1,
     :       vmin, vmax, indxpgv_min, indxpgv_max, pgv(j)) 
            call abs_mnmaxidx(dis4gmroti, 1, npts(j), 1,
     :       dmin, dmax, indxpgd_min, indxpgd_max, pgd(j)) 
     
          END DO

          pga_gmroti50(idamp) = sqrt(pga(1)*pga(2))
        
          pgv_gmroti50(idamp) = sqrt(pgv(1)*pgv(2))

      pgd_gmroti50(idamp) = sqrt(pgd(1)*pgd(2))

          deallocate( vel4gmroti, dis4gmroti )

        END DO   BIG LOOP2 OVER DAMPING
        
!  ^^^^^^^^^^^END SECTION FOR SORTING AND OBTAINING INTENSTIY MEASURES  ^^^^^ 

  
!  ^^^^^^^^^^^BEGIN SECTION FOR WRITING OUTPUT  ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^            

! Now write out the seismic intensity values:

        IF (output_separate_files) THEN

          LOOP OVER FILE FOR PAIR OF TIME SERIES AND EACH DAMPING: 
     :    DO idamp = 1, ndamp
          
            input_path = ' '
            call get_path_from_file_name(f_in(1),nc_f_in(1),
     :                                   input_path,nc_input_path)
            f_out(1) = ' '
            f_out(1) = f_out_in(1:nc_f_out_in)//'.'//
     :                 f_in(1)(nc_input_path+1:nc_f_in(1))
            call trim_c(f_out(1),nc_f_out(1))
            f_out(1) = f_out(1)(1:nc_f_out(1))//'.damp'
            call trim_c(f_out(1), nc_f_out(1))
            write(f_out(1)(nc_f_out(1)+1:nc_f_out(1)+4),'(f4.2)') 
     :                 damp(idamp)
            call trim_c(f_out(1), nc_f_out(1))
            f_out(1) = f_out(1)(1:nc_f_out(1))//'.out'
            call trim_c(f_out(1), nc_f_out(1))
            call get_lun(nu_out(1))
            open(nu_out(1),file=f_out(1)(1:nc_f_out(1)),
     :           status='unknown')


            write(nu_out(1),'(a)') 
     :  '! Note: pga_rotnn and pgv_rotnn, for nn = 00, 50 and 100, '// 
     :  'are based on the distributions of pga and pgv over'
            write(nu_out(1),'(a)') 
     :   '! all rotation angles, in the same way as rotdnn. '//  
     :   'Note that for consistency with the notation "gmrotdnn",' 
            write(nu_out(1),'(a)') 
     :   '! the notation for the non-geometric mean, '//
     :   'orientation-independent PSA is "rotdnn", rather than the '
            write(nu_out(1),'(a)') 
     :   '! more logical "psa_rotdnn".  The paper that introduced '//
     :   'rotdnn (Boore, BSSA 2010) also introduced rotinn, '
            write(nu_out(1),'(a)')
     :   '! which is akin to gmrotinn; that paper recommended '//
     :   ' against its use, however, and therefore it is not'
            write(nu_out(1),'(a)')
     :   '! one of the seismic intensity measures provided by this '//
     :      'program.'
            write(nu_out(1),'(a)')
     :                              '!'
            write(nu_out(1),'(a)')
     :   '! Also note that psa is computed for all periods '//
     :     'specified in the control file, even IF they are beyond'
            write(nu_out(1),'(a)')
     :   '! what one would consider to be the maximum usable period '//
     :     'based on considerations of the low-cut filter frequencies.'
            write(nu_out(1),'(a)')
     :   '! It is up to the user to decide what periods to use in '//
     :     'an analysis.'
            write(nu_out(1),'(a)')
     :                              '!'
            write(nu_out(1),'(a)')
     :   '! period = -1, 0 for pgv, pga; "units" are those for '//
     :     'psa and pga; the units of pgv are cm/s'
          write(nu_out(1),'(a)')
     :                              '!'
     


          write(nu_out(1),'(
     :      2x,a,
     :      2x,a,
     :      4x,a,
     :      1x,a, 1x,a,
     :      3x,a, 1x,a,
     :      3x,a, 1x,a,
     :      1x,a,
     :      3x,a, 3x,a,
     :      2x,a, 1x,a,
     :      3x,a, 1x,a,
     :      3x,a, 3x,a, 2x,a,
     :      1x,a,
     :      5x,a, 5x,a, 4x,a,
     :      2x,a,
     :      2x,a,
     A      1x,a,
     A      1x,a,
     :      4x,a, 4x,a,
     :      3x,a, 1x,a,
     :      1x,a,
     :      1x,a, 1x,a, 1x,a,
     :      3x,a, 3x,a, 2x,a
     :                               )')
     :     'period',
     :     'damp',
     :     'units',
     :     'azm1', 'azm2',
     :     'flc1', 'nslope1',
     :     'flc2', 'nslope2',
     :     'tmax4penalty',
     :     'psa_1_ar', 'psa_2_ar',
     :     'psa_gm_ar', 'psa_larger_ar', 
     :     'gmroti50',  'gmroti50angle',
     :     'gmrotd00', 'gmrotd50', 'gmrotd100',  
     :        'gmrotd100angle',
     :     'rotd00', 'rotd50', 'rotd100', 
     :        'rotd00angle',
     A        'rotd50angle1',
     A        'rotd50angle2',
     :        'rotd100angle',
     :     'sd_1_ar', 'sd_2_ar', 
     :     'sd_gm_ar', 'sd_larger_ar', 
     :     'sdgmroti50',   
     :     'sdgmrotd00', 'sdgmrotd50', 'sdgmrotd100',  
     :     'sdrotd00', 'sdrotd50', 'sdrotd100' 
          
            per4print = -1.0
            write(nu_out(1), '(
     :        1x,f7.4,
     :        6x,
     :        1x,a8,
     :        1x,i4, 1x,i4,
     :        1x,f6.3, 5x,i3,
     :        1x,f6.3, 5x,i3,
     :        6x,f7.4,
     :        1x,es10.3, 1x,es10.3, 
     :        1x,es10.3, 
     :        4x,es10.3,
     :        1x,es10.3, 
     :        8x,f6.1,
     :        1x,es10.3, 
     :        1x,es10.3, 
     :        1x,es10.3,
     :        9x,f6.1,
     :        1x,es10.3, 
     :        1x,es10.3, 
     :        1x,es10.3,
     :        7x,f6.1,
     :        8x,f6.1,
     :        7x,f6.1,
     :        7x,f6.1,
     :        1x,es10.3, 
     :        3x,es10.3,
     :        1x,es10.3,
     :        1x,es10.3, 
     :        1x,es10.3, 
     :        2x,es10.3,
     :        1x,es10.3, 
     :        1x,es10.3, 
     :        2x,es10.3, 2x,es10.3, 
     :        1x,es10.3
     :                                         )')
     :      per4print, 
     :      units_acc_vel_c, 
     :      int(azm_in(1)), int(azm_in(2)),
     :      flc(1), nslope(1),
     :      flc(2), nslope(2),
     :      tmax4penalty,
     :      pgv_1_ar, pgv_2_ar,
     :      pgv_gm_ar, 
     :      pgv_larger_ar, 
     :      pgv_gmroti50(idamp), 
     :      gmroti50angle(idamp), 
     :      pgv_gmrot00,  
     :      pgv_gmrot50, 
     :      pgv_gmrot100, 
     :      pgvgmrot100ang, 
     :      pgv_rot00,   
     :      pgv_rot50,   
     :      pgv_rot100,
     :      pgvrot00ang,
     :      pgvrot50ang1, pgvrot50ang2,
     :      pgvrot100ang
          
            per4print =  0.0
            write(nu_out(1), '(
     :        1x,f7.4,
     :        6x,
     :        1x,a8,
     :        1x,i4, 1x,i4,
     :        1x,f6.3, 5x,i3,
     :        1x,f6.3, 5x,i3,
     :        6x,f7.4,
     :        1x,es10.3, 1x,es10.3, 
     :        1x,es10.3, 
     :        4x,es10.3,
     :        1x,es10.3, 
     :        8x,f6.1,
     :        1x,es10.3, 
     :        1x,es10.3, 
     :        1x,es10.3,
     :        9x,f6.1,
     :        1x,es10.3, 
     :        1x,es10.3, 
     :        1x,es10.3,
     :        7x,f6.1,
     :        8x,f6.1,
     :        7x,f6.1,
     :        7x,f6.1,
     :        1x,es10.3, 
     :        3x,es10.3,
     :        1x,es10.3,
     :        1x,es10.3, 
     :        1x,es10.3, 
     :        2x,es10.3,
     :        1x,es10.3, 
     :        1x,es10.3, 
     :        2x,es10.3, 2x,es10.3, 
     :        1x,es10.3
     :                                         )')
     :        per4print, 
     :        units_acc_vel_c, 
     :        int(azm_in(1)), int(azm_in(2)),
     :        flc(1), nslope(1),
     :        flc(2), nslope(2),
     :        tmax4penalty,
     :        acc_factor*pgv_1_ar, acc_factor*pgv_2_ar,
     :        acc_factor*pga_gm_ar, 
     :        acc_factor*pga_larger_ar, 
     :        acc_factor*pga_gmroti50(idamp),
     :        gmroti50angle(idamp), 
     :        acc_factor*pga_gmrot00, 
     :        acc_factor*pga_gmrot50, 
     :        acc_factor*pga_gmrot100, 
     :        pgagmrot100ang, 
     :        acc_factor*pga_rot00,    
     :        acc_factor*pga_rot50,   
     :        acc_factor*pga_rot100,
     :        pgarot00ang,
     :        pgarot50ang1, pgarot50ang2,
     :        pgarot100ang
     
            DO iper = 1, nper_max
              sdfctr = (period(iper)/twopi)**2
              write(nu_out(1), '(
     :          1x,f7.4,
     :          1x,f5.3,
     :          1x,a8,
     :          1x,i4, 1x,i4,
     :          1x,f6.3, 5x,i3,
     :          1x,f6.3, 5x,i3,
     C        6x,f7.4,
     :        1x,es10.3, 
     :        1x,es10.3, 
     :        1x,es10.3, 
     :        4x,es10.3,
     :        1x,es10.3, 
     :        8x,f6.1,
     :        1x,es10.3, 
     :        1x,es10.3, 
     :        1x,es10.3,
     :        9x,f6.1,
     :        1x,es10.3, 
     :        1x,es10.3, 
     :        1x,es10.3,
     B        7x,f6.1,
     A        8x,f6.1,
     A        7x,f6.1,
     :        7x,f6.1,
     :        1x,es10.3, 
     :        1x,es10.3, 
     :        1x,es10.3, 
     :        3x,es10.3,
     :        1x,es10.3,
     :        1x,es10.3, 
     :        1x,es10.3, 
     :        2x,es10.3,
     :        1x,es10.3, 
     :        1x,es10.3,
     :        1x,es10.3
     :                                          )')
     :        period(iper), 
     :        damp(idamp),
     :        units_acc_vel_c, 
     :        int(azm_in(1)), int(azm_in(2)),
     :        flc(1), nslope(1),
     :        flc(2), nslope(2),
     C        tmax4penalty,
     :        acc_factor*psa_1_ar(iper,idamp), 
     :        acc_factor*psa_2_ar(iper,idamp),
     :        acc_factor*psa_gm_ar(iper,idamp), 
     :        acc_factor*psa_larger_ar(iper,idamp), 
     :        acc_factor*gmroti50(iper,idamp), 
     :        gmroti50angle(idamp), 
     :        acc_factor*gmrotd00(iper,idamp), 
     :        acc_factor*gmrotd50(iper,idamp), 
     :        acc_factor*gmrotd100(iper,idamp), 
     :        gmrotd100ang(iper,idamp), 
     :        acc_factor*rotd00(iper,idamp),    
     :        acc_factor*rotd50(iper,idamp),   
     :        acc_factor*rotd100(iper,idamp),
     B        rotd00ang(iper,idamp),
     A        rotd50ang1(iper,idamp),
     A        rotd50ang2(iper,idamp),
     :        rotd100ang(iper,idamp),
     :        sdfctr*psa_1_ar(iper,idamp),  
     :        sdfctr*psa_2_ar(iper,idamp),  
     :        sdfctr*psa_gm_ar(iper,idamp),  
     :        sdfctr*psa_larger_ar(iper,idamp), 
     :        sdfctr*gmroti50(iper,idamp),  
     :        sdfctr*gmrotd00(iper,idamp), 
     :        sdfctr*gmrotd50(iper,idamp), 
     :        sdfctr*gmrotd100(iper,idamp), 
     :        sdfctr*rotd00(iper,idamp),   
     :        sdfctr*rotd50(iper,idamp),   
     :        sdfctr*rotd100(iper,idamp)
     
            END DO
     
            close(nu_out(1))
          
          END DO  
     :    LOOP OVER FILE FOR PAIR OF TIME SERIES AND EACH DAMPING
          
        END IF   ! output separate files
        
        
        
        
        IF (.not. output_separate_files) THEN   ! not separate files for each pair of time series
        
          LOOP OVER FILE FOR EACH DAMPING: DO idamp = 1, ndamp
        
            write(*,*) ' writing output to unit, file: ',
     :                 nu_out(idamp), f_out(idamp)(1:nc_f_out(idamp))

            write(nu_out(idamp),'(
     :      a70, 
     :      1x,a70, 
     :      3x,f8.5, 3x,f8.5,
     :      1x,f6.3, 5x,i3,
     :      1x,f6.3, 5x,i3,
     :      7x,f6.1,
     :      6x,a8,
     :      3x,es12.6,  3x,es12.6, 
     :                 3x,es12.6, 
     :      8x,f6.1,  
     :      1x,es12.6,  1x,es12.6, 
     :      1x,es12.6,  9x,f6.1,
     :      3x,es12.6,  9x,f6.1,
     :      1x,es11.4, 1x,es11.4, 
     :      8x,f8.5,
     :      1x,es11.4, 1x,es11.4,  
     :      8x,f8.5,
     :      1x,es11.4, 1x,es11.4,  
     A      8x,f8.5,
     :      1x,es11.4, 1x,es11.4, 2x,es11.4, 
     :      6x,f6.1, 7x,f6.1, 7x,f6.1,
     :             7x,f6.1,
     :      1x,es11.4, 1x,es11.4, 2x,es11.4, 
     :      6x,f6.1, 7x,f6.1, 7x,f6.1, 
     :             7x,f6.1,
     :      1x,es11.4, 1x,es11.4, 2x,es11.4, 
     :      6x,f6.1, 7x,f6.1, 7x,f6.1,
     :             7x,f6.1,
     B      1x,f5.3,
     :      200(3x,f7.4,
     :          9x,f8.5,
     :          1x,es12.6,
     :          1x,es12.6, 
     :          1x,es12.6, 
     :          1x,es12.6, 
     :          4x,es12.6, 
     :          2x,es12.6,
     :          1x,es12.6, 
     :          1x,es12.6,
     :          1x,es12.6,
     :          1x,es12.6,  
     :          4x,f6.1, 
     :          5x,f6.1, 5x,f6.1, 
     :          5x,f6.1)
     :                                 )') 
     :      f_in(1)(1:nc_f_in(1)), 
     :      f_in(2)(1:nc_f_in(2)), 
     :      log10(real(npts(1))), log10(real(npts(2))),
     :      flc(1), nslope(1),
     :      flc(2), nslope(2),
     :      tmax4penalty,
     :      units_acc_vel_c,
     :      acc_factor*pga_gmroti50(idamp), pgv_gmroti50(idamp), 
     :      pgd_gmroti50(idamp),    
     :      gmroti50angle(idamp),
     :      acc_factor*pga_gmrot50,  pgv_gmrot50, 
     :      acc_factor*pga_gmrot100, pgagmrot100ang,
     :                 pgv_gmrot100, pgvgmrot100ang,
     :      acc_factor*pga_1_ar, acc_factor*pga_2_ar, 
     :                 log10(real(n_a_subset)),
     :                 pgv_1_ar,            pgv_2_ar, 
     :                 log10(real(n_v_subset)),
     :                 pgd_1_ar,            pgd_2_ar, 
     A                 log10(real(n_d_subset)),
     : acc_factor*pga_rot00,acc_factor*pga_rot50,acc_factor*pga_rot100, 
     :                 pgarot00ang, pgarot50ang1, pgarot50ang2, 
     :                          pgarot100ang,
     :            pgv_rot00,           pgv_rot50,           pgv_rot100, 
     :                 pgvrot00ang, pgvrot50ang1, pgvrot50ang2, 
     :                          pgvrot100ang,
     :            pgd_rot00,           pgd_rot50,           pgd_rot100, 
     :                 pgdrot00ang, pgdrot50ang1, pgdrot50ang2,  
     :                                 pgdrot100ang,
     B      damp(idamp),
     :      (period(iper),
     :       log10(real(n_rd_subset(iper, idamp))),
     :       acc_factor*aa_1_ar(iper,idamp), 
     :       acc_factor*aa_2_ar(iper,idamp),  
     :       acc_factor*psa_1_ar(iper,idamp), 
     :       acc_factor*psa_2_ar(iper,idamp),
     :       acc_factor*psa_gm_ar(iper,idamp), 
     :       acc_factor*psa_larger_ar(iper,idamp), 
     :       acc_factor*gmroti50(iper,idamp), 
     :       acc_factor*rotd00(iper,idamp),    
     :       acc_factor*rotd50(iper,idamp), 
     :       acc_factor*rotd100(iper,idamp),   
     :       rotd00ang(iper,idamp), 
     :       rotd50ang1(iper,idamp),  rotd50ang2(iper,idamp),
     :                  rotd100ang(iper,idamp), 
     :         iper = 1, nper_max)


      
          END DO LOOP OVER FILE FOR EACH DAMPING
          
        END IF ! not separate files for each pair of time series

        deallocate( a_in_interp ) 
        deallocate( a_out )
       
        call timer_subroutine(time_stop_one_file)
        write(nu_sum,*)
        write(nu_sum,'(a, 1x,i8, a, 1x,es12.5, a)') 
     :   ' For file '//f_in(1)(1:nc_f_in(1))//' npts = ', npts(1),
     :   ' and calc time = ', 
     :     (time_stop_one_file - time_start_one_file)/60.0, ' m'

      END DO  BIG LOOP OVER INPUT FILES

! ##########################  END LOOP OVER INPUT FILES #####################

        call timer_subroutine(time_stop_all_files)
        write(nu_sum,*)
        write(nu_sum,'(a, 1x,i8, a, 1x,es12.5, a)') 
     :   ' For ', nrecs, ' files, the total calculation time = ',
     :     (time_stop_all_files - time_start_all_files)/60.0, ' m'

      close(nu_sum)
      close(nu_ctl)
      
      IF (.not. output_separate_files) THEN
      
        DO idamp = 1, ndamp
          close(nu_out(idamp))
        END DO
        
      END IF
 
      end
! ---------------------------------------------------- SMC2PSA_Rot_GMRot_Rot_Osc_TS

 
! ---------------------------------------------------------------- get_00_50_100_values
      SUBROUTINE get_00_50_100_values(y, n, y00, y50, y100, 
     :               index_n00, index_1_n50, index_2_n50, index_n100)
     
! Dates: 07/02/10 - Revised to handle odd, even n properly      
!        01/25/18 - Set index_n50 to correspond to the w50, w50p1 value closest to y50
!        02/03/18 - Need to keep the two indx50 values separate (on either side of
!                   median if n is even).
          
       real y(*), work(n), real_nd2
       integer indx(n)
       
       work = 0.0          
       DO iz = 1, n
         work(iz) =  y(iz)
       END DO

       indx = 0.0 
       call indexx(n, work, indx)  ! use this rather than select because
                                   ! want to keep track of the rotation angle

       index_n00  = indx(1)
       y00 = work(index_n00)

       real_nd2 = real(n)/2.0
       nd2 = int(real_nd2)
       IF (modulo(real_nd2,1.0) == 0.0) THEN
         n50 = nd2      ! even
         index_1_n50 = indx(n50)
         index_2_n50 = indx(n50+1)
         w50 = work(index_1_n50)        
         w50p1 = work(index_2_n50)            
         y50 = 0.5 * (w50 + w50p1) 
       ELSE
         n50 = nd2 + 1  ! odd
         y50 = work(indx(n50))        
         index_1_n50 = indx(n50)
         index_2_n50 = indx(n50)
       END IF
        
       index_n100  = indx(n)
       y100 = work(index_n100) 
       
       RETURN
      END
! ---------------------------------------------------------------- get_00_50_100_values
          
      include 'smc2psa_util_subs.for'     
   
!      include '\forprogs\acc2vd.for'     
!      include '\forprogs\rmvtrend.for'     
!      include '\forprogs\rotate.for'     
!      include '\forprogs\get_lun.for'     
!      include '\forprogs\skip.for'     
!      include '\forprogs\smcread.for'     
!      include '\forprogs\mnmaxidx.for'     
!      include '\forprogs\abs_mnmaxidx.for'     
!      include '\forprogs\trim_c.for'     
!      include '\forprogs\upstr.for'     
!      include '\forprogs\smc_npts.for'     
!      include '\forprogs\distaz.for'     
!      include '\forprogs\rc_subs.for'     
!      include '\forprogs\skipcmnt.for'     
!      include '\forprogs\rscalc_interp_acc.for'
!      include '\forprogs\moment.for'
!      include '\forprogs\select.for'
!      include '\forprogs\indexx.for'
  


 
